
/* grace library dsl */

// #t and #f

1 0 > '#t def
1 0 < '#f def

// source quote

["'" scan cat quote eval] 'qquot defun
[scan quote] 'squot defun

// prefix functions

[qquot squot swap defmac] 'defmac: defmac
defmac: defun: [qquot squot swap defun]
defmac: def:   [qquot squot swap def]
defmac: while: [squot squot swap 'while]
defmac: if:    [squot squot swap 'if]
defmac: ife:   [squot squot squot -rot swap 'ife]
defmac: cond:  [squot 'cond]

// verbose scanning

// [ scan dup "[scanning " swap cat "]" cat pr cr ] 'scan defun

// variable with resulting source

def: src ""

// cond : [[cond.0] [cons.0]...[cond.n] [cons.n]] - ?

defun: cond
[
  while: [dup length 0 >]
  [
    ife: [split dive eval]
      [soar splits nip eval []]
      [soar splits drop]
  ]
  drop
]

/* misc */

defun: srcat [src swap cat 'src set]

// generates associative array with
// description of library function
// from inline dsl source code
defmac: fun
[
  // create associative array
  new-asa
  // function declaration
  scan "name" rot put
  // expecting ":"
  ["':' expected" pr cr] scan ":" = not if
  // parameters until "-"
  [] "ptyp" rot put
  [] "pnam" rot put
  while: [scan dup "-" = not]
  [
    // : asa type
    over "ptyp" swap get
    // : asa type ptyp
    cons "ptyp" rot put
    // : asa
    scan
    // : asa name
    over "pnam" swap get
    // : asa name pnam
    cons "pnam" rot put
    // : asa
  ]
  drop
  // results until ";"
  [] "rtyp" rot put
  [] "rnam" rot put
  while: [scan dup ";" = not]
  [
    // : asa type
    over "rtyp" swap get
    // : asa type rtyp
    cons "rtyp" rot put
    // : asa
    scan
    // : asa name
    over "rnam" swap get
    // : asa name rnam
    cons "rnam" rot put
    // : asa
  ]
  drop
  // code until "end"
  "" "src" rot put
  // debug info
//  ds dup pr cr
  while: [scan dup "end" = not]
  [
    // : asa str
    over "src" swap get
    // : asa str src
    cat "src" rot put
    // : asa
  ]
  drop
  // debug info
//  ds dup pr cr
]

// generates d source code from
// description of library function
defun: tosrc
[ // asa - str
  // : asa
  "void " srcat
  "name" over get srcat
  "()\n{\n" srcat
  //

]

// test library function

fun add : int a int b - int c ;
  c=a+b;
end

// "xxx" pr cr

dup pr cr
tosrc
"source:\n" src cat pr cr



