
module grace_prim_file;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prim()
{
  dict_addnf("file-read"  ,&p_file_read  ,      ["str"],["bar"]);
  dict_addnf("file-rdstr" ,&p_file_rdstr ,      ["str"],["str"]);
  dict_addnf("file-write" ,&p_file_write ,["bar","str"],[]);
  dict_addnf("file-wrstr" ,&p_file_wrstr ,["str","str"],[]);
  dict_addnf("file-append",&p_file_append,["bar","str"],[]);
  dict_addnf("file-rename",&p_file_rename,["str","str"],[]);
  dict_addnf("file-delete",&p_file_delete,      ["str"],[]);
  dict_addnf("file-size?" ,&p_file_size  ,      ["str"],["int"]);
  dict_addnf("file-exist?",&p_file_exist ,      ["str"],["log"]);
  dict_addnf("file-copy"  ,&p_file_copy  ,["str","str"],[]);
  dict_addnf("chdir"      ,&p_chdir      ,      ["str"],[]);
  dict_addnf("mkdir"      ,&p_mkdir      ,      ["str"],[]);
  dict_addnf("rmdir"      ,&p_rmdir      ,      ["str"],[]);
  dict_addnf("cwd?"       ,&p_getcwd     ,           [],["str"]);
  dict_addnf("xxx"        ,&p_xxx        ,           [],[]);
}

static this()
{
  reg_prims~=&reg_prim;
}

void p_file_read()
{
//  void[] b=read(dpop_str());
//  printf("b.ptr=%p b.len=%i\n",b.ptr,b.length);
//  dpush_bar(b);
  dpush_bar(read(dpop_str()));
}

void p_file_rdstr()
{
  char[] s=cast(char[])std.file.read(dpop_str());
//  printf("p=%p l=%i\n",s.ptr,s.length);
  dpush_str(s);
}


void p_xxx()
{
  char[] s=dpop_str();
//  printf("p=%p l=%i\n",s.ptr,s.length);
  writefln("%s",s);
}

void p_file_write()
{
  char[] n=dpop_str();
  void[] b=dpop_bar();
  write(n,b);
}

void p_file_wrstr()
{
//  writef("name: ");
  char[] n=dpop_str();
//  writef(n," data:");
  char[] b=dpop_str();
//  writef(b," ");
  write(n,b);
//  writef(b,"done\n");
}

void p_file_append()
{
  char[] n=dpop_str();
  void[] b=dpop_bar();
  append(n,b);
}

void p_file_rename()
{ // oldname newname -
  char[] nn=dpop_str();
  char[] on=dpop_str();
  std.file.rename(on,nn);
}

void p_file_delete()
{
  char[] n=dpop_str();
  std.file.remove(n);
}

void p_file_size()
{
  char[] n=dpop_str();
  dpush_int(getSize(n));
}

void p_file_exist()
{
  char[] n=dpop_str();
  dpush_log(exists(n));
}

void p_file_copy()
{ // destination source -
  char[] sn=dpop_str();
  char[] dn=dpop_str();
  copy(sn,dn);
}

void p_chdir()
{
  char[] n=dpop_str();
  chdir(n);
}

void p_mkdir()
{
  char[] n=dpop_str();
  mkdir(n);
}

void p_rmdir()
{
  char[] n=dpop_str();
  rmdir(n);
}

void p_getcwd()
{
  dpush_str(getcwd());
}
