
module grace_prim_str;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prim()
{
  // char and stringfunctions
  dict_addnf("="     ,&p_equ_c      ,["chr","chr"],["log"]);
  dict_addnf("="     ,&p_equ_s      ,["str","str"],["log"]);
  dict_addnf("!="    ,&p_nequ_c     ,["chr","chr"],["log"]);
  dict_addnf("!="    ,&p_nequ_s     ,["str","str"],["log"]);
  dict_addnf("cat"   ,&p_cat_cc     ,["chr","chr"],["str"]);
  dict_addnf("cat"   ,&p_cat_sc     ,["str","chr"],["str"]);
  dict_addnf("cat"   ,&p_cat_cs     ,["chr","str"],["str"]);
  dict_addnf("cat"   ,&p_cat_ss     ,["str","str"],["str"]);
//  dict_addnf("head"  ,&p_head       ,["str"]      ,[ "*" ]);
//  dict_addnf("tail"  ,&p_tail       ,["str"]      ,["str"]);
//  dict_addnf("cons"  ,&p_cons       ,[ "*" ,"str"],["str"]);
//  dict_addnf("split" ,&p_split      ,["str"]      ,[ "*" ]);
//  dict_addnf("scons" ,&p_scons      ,["str", "*" ],["str"]); // swap cons
//  dict_addnf("splits",&p_splits     ,["str"]      ,[ "*" ]); // split swap
  dict_addnf("length",&p_length     ,["str"]      ,["int"]);
}

static this()
{
  reg_prims~=&reg_prim;
}

// --------------------
// ----- strings

void p_equ_c()
{
  char c0=cell2chr(dpop());
  char c1=cell2chr(dpop());
  int eq=(c1==c0);
  dpush_log(eq);
}

void p_equ_s()
{
  char[] s0=cell2str(dpop());
  char[] s1=cell2str(dpop());
  int eq=(s1==s0);
//  printf("s0=\"%s\" s1=\"%s\" eq=%i\n",toStringz(s0),toStringz(s1),eq);
  dpush_log(eq);
}

void p_nequ_c()
{
  char c0=cell2chr(dpop());
  char c1=cell2chr(dpop());
  dpush_log(c0!=c0);
}

void p_nequ_s()
{
  char[] s0=cell2str(dpop());
  char[] s1=cell2str(dpop());
  dpush_log(s1!=s0);
}

void p_cat_ss()
{
  char[] s1=cell2str(dpop());
  char[] s0=cell2str(dpop());
  dpush(str2cell(s0~s1));
}

void p_cat_sc()
{
  char   c=cell2chr(dpop());
  char[] s=cell2str(dpop());
  dpush(str2cell(s~c));
}

void p_cat_cs()
{
  char[] s=cell2str(dpop());
  char   c=cell2chr(dpop());
  dpush(str2cell(c~s));
}

void p_cat_cc()
{
  char c1=cell2chr(dpop());
  char c0=cell2chr(dpop());
  dpush(str2cell(""~c0~c1));
}
/*
void p_catsi()
{
  char   c=dpop_int();
  char[] s=dpop_str();
  dpush(str2cell(s~c));
}

void p_head()
{
  char[] s=cell2str(dpop());
  if (s.length>0)
    dpush(int2cell(s[0]));
}

void p_tail()
{
  char[] s=cell2str(dpop());
  if (s.length>1)
    dpush(str2cell(s[1..$]));
  else
    dpush(str2cell(""));
}

void p_cons()
{
  char[] s=cell2str(dpop());
  char   e=cast(char)cell2int(dpop());
  dpush(str2cell(e~s));
}

void p_split()
{
  char[] s=cell2str(dpop());
  if (s.length>0)
    dpush(int2cell(s[0]));
  if (s.length>1)
    dpush(str2cell(s[1..$]));
  else
    dpush(str2cell(""));
}

void p_scons()
{
  char   e=cell2int(dpop());
  char[] s=cell2str(dpop());
  dpush(str2cell(e~s));
}

void p_splits()
{
  char[] s=cell2str(dpop());
  if (s.length>1)
    dpush(str2cell(s[1..$]));
  else
    dpush(str2cell(""));
  if (s.length>0)
    dpush(int2cell(s[0]));
}
*/
void p_length()
{
  dpush(int2cell(cell2str(dpop()).length));
}
