
module grace_prim_system;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

import std.process;
import std.c.windows.windows;
//import std.loader;
import std.gc;

void reg_prim()
{
  dict_addnf("system",&p_system,["str"],["int"]);
  dict_addnf("load-module",&p_load_module,["str"],[]);
}

static this()
{
  reg_prims~=&reg_prim;
}

void p_system()
{
  dpush_int(std.process.system(dpop_str()));
}

struct iniStruct
{
  void  *gc;
  void  *reg;
  void  *stk;
}

alias void function(void*) Initialize_fp;
alias void function() Terminate_fp;
alias void function() voidfun;
alias char[][] function() aacfun;

void p_load_module()
{
  HMODULE h;
  FARPROC fp;
  Initialize_fp initialize;
  Terminate_fp  terminate;
  iniStruct inst;

  printf("Start Dynamic Link...\n");

  // --------------------

  h = LoadLibraryA(dpop_str().toStringz());
  if (h == null)
  {
    printf("error loading dll\n");
    dpush_int(1);
    return;
  }

  // --------------------
  //D5mydll16MyDLL_InitializeFPvZv
  //D6tstmod16MyDLL_InitializeFPvZv
  fp = GetProcAddress(h, "D6tstmod16MyDLL_InitializeFPvZv");
  if (fp == null)
  {
    printf("error loading symbol Initialize()\n");
    dpush_int(1); // failure
    return;
  }
  initialize=cast(Initialize_fp)fp;
  inst.gc=std.gc.getGCHandle();
  inst.reg=&dict_addn;
  inst.stk=&stk;
  printf("&dict_addn=%p\n",&dict_addn);
  (*initialize)(&inst);

  // --------------------

/*
  fp=GetProcAddress(h, "job1");
  if (fp == null)
  {
    printf("error loading symbol job1()\n");
    dpush_int(1); // failure
    return;
  }
  else
  {
    printf("&dict_addn=%p\n",&dict_addn);
    void *p=&dict_addn;
    printf("&dict_addn=%p\n",p);
    (*(cast(void function(void*))fp))(p);
  }

  fp=GetProcAddress(h, "job2");
  if (fp == null)
  {
    printf("error loading symbol job2()\n");
  }
  else
  {
    char[][] s=(*(cast(aacfun)fp))();
    writefln(s);
  }

  // --------------------

  fp = GetProcAddress(h, "D5mydll15MyDLL_TerminateFZv");
  if (fp == null)
  {
    printf("error loading symbol MyDLL_Terminate()\n");
    dpush_int(1); // failure
    return;
  }
  mydll_terminate = cast(MyDLL_Terminate_fp) fp;
  (*mydll_terminate)();

  // --------------------

  if (FreeLibrary(h) == FALSE)
  {
    printf("error freeing mydll.dll\n");
    dpush_int(1); // failure
    return;
  }
  printf("End...\n");
*/
  dpush_int(0); // success
}


